﻿
Public Class frmOX400

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        Dim frmobj As New frmStart
        frmobj.ShowDialog()
        If frmobj.Result < 0 Then
            Exit Sub
        End If
        txtpath.Text = frmobj.Path
        txtfilename.Text = frmobj.Filename
        Try
            Clslog.WriteA(txtpath.Text & "\" & txtfilename.Text, "DateTime,O2ppm,ErrCode,AlramCode")
        Catch ex As Exception
            MsgBox("Write File Error")
            Exit Sub
        End Try
        COMM_set()
        COMM_start()
    End Sub
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        COMM_bat()

    End Sub
    Private Sub btnstop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStop.Click
        COMM_end()
    End Sub
    Private Sub frmox400_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing '終了処理
        COMM_end()
    End Sub
    'コントロール名 SerialPortOX 
    'ポート　COM NumCOM.Value
    '通信方式 単方向（送信のみ）、非同期
    'データ形式 ASCII
    'ボーレート 38400 bps
    'データ長 8ビット
    'パリティ なし
    'ストップビット 1ビット
    'フロー制御 なし
    'タイムアウト
    Private Sub COMM_set()
        SerialPortOX.PortName = "COM" & CStr(NumCOM.Value)
        SerialPortOX.BaudRate = 38400
        SerialPortOX.DataBits = 8
        SerialPortOX.Handshake = IO.Ports.Handshake.None
        SerialPortOX.Parity = IO.Ports.Parity.None
        SerialPortOX.StopBits = IO.Ports.StopBits.One
        SerialPortOX.NewLine = ControlChars.Cr
        SerialPortOX.ReadTimeout = 400

        Timer1.Interval = Numsec.Value * 1000 '受信周期
        Timer1.Enabled = False
    End Sub
    Private Sub COMM_start()
        Try
            SerialPortOX.Open()
        Catch ex As Exception
            'ポートOPENエラー
            MsgBox("Port Open Error")
        End Try
        Try
            SerialPortOX.WriteLine("TS")
            Timer1.Enabled = True '受信タイマー作動
        Catch ex As Exception
            '通信開始エラー
        End Try
    End Sub
    Private Sub COMM_end()
        Try
            SerialPortOX.WriteLine("")
        Catch ex As Exception
            '通信終了エラー
        End Try
        Try
            Timer1.Enabled = False 'タイマーストップ
            SerialPortOX.Close()

        Catch ex As Exception
            'ポートCLOSEエラー()
        End Try
    End Sub

    '    ・データログパケット
    '通信ターミナルから「TS」を入力すると図 6.15 に示すようなデータログパケットが通信ターミ
    'ナルに出力されます。データ更新周期は約200msです。データログを中止するにはリターンキー
    '「CR」を入力してください。再開するには、再度「TS」を入力します。

    'AAAA.AAA,BBB,CCCC,DDDD CR

    'データの区切り記号は「,」です。終端記号
    '図 6.15データログパケットの構成
    'データログパケットに含まれる内容は、以下のような意味になります。
    '表 6.2　データの内容
    'データ 内　容
    'AAAA.AAA 酸素濃度値
    'BBB 単位
    'CCCC エラー（16進数表示）
    'DDDD アラーム（16進数表示）

    '1）酸素濃度値
    'AAAA.AAAで表示され小数点以下3桁まで出力されます。
    '（注）出力スムージングが設定されている場合、これを含んだ値が酸素濃度値となります。

    '2）単位
    'BBBで表示されます。　出力文字は、「％」または「ppm」

    '3）エラー
    'CCCCで表されます。出力文字は16進数で表され、エラーの内容と出力文字は、次の通
    'りです。
    '出力文字 エラー内容
    '0001 Err1：センサ異常
    '0002 Err2：ヒータ温度異常
    '0004 Err3：温度センサ断線
    '0008 Err4：装置温度異常
    '0010 Err5：CPU異常
    '0020 Err6：FAN停止
    'エラーが複数発生している場合は、出力文字の論理和で出力されます。
    '例1： 0003：Err1とErr2が発生している。
    '例2： 0017：Err1,Err2,Err3,Err5の4つのエラーが発生している。

    '4）アラーム
    'DDDDで表されます。出力文字は 16進数で表され、エラーの内容と出力文字は、次の
    '通りです。
    'アラーム内容と出力文字一覧
    '出力文字 アラーム内容
    '0001 ALM1：ヒータ不安定（温度不安定）
    '0002 ALM2：センサ不良
    '0004 ALM3：起電力異常
    '0008 ALM4：不斉電圧異常
    '0010 ALM5：校正異常
    '0020 ALM6：センサ抵抗値異常
    '0040 ALM7：酸素濃度上下限異常
    '0080 ALM8：レンジオーバ異常
    'アラームが複数発生している場合は、出力文字の論理和で出力されます。
    '例1：00C0：ALM7とALM8が発生している。
    Private Sub COMM_bat()

        Dim strdata As String = ""
        Dim strsubdata() As String
        Dim dblO2ppm As Double
        Dim strErrcode As String
        Dim strALMcode As String
        Dim len As Integer
        Dim strMsg As String
        Try
            SerialPortOX.DiscardInBuffer()
            strdata = SerialPortOX.ReadLine()
            strdata = SerialPortOX.ReadLine() '受信
        Catch ex As Exception
            '受信エラー
        End Try

        len = strdata.Length '受信文字数

        If len < 10 Then Exit Sub

        Try '受信文字処理

            strsubdata = Split(strdata, ",")

            'ppm 表示例
            If strsubdata(1) = "ppm" Then
                dblO2ppm = CDbl(strsubdata(0))

            ElseIf strsubdata(1) = "%" Then
                dblO2ppm = CDbl(strsubdata(0)) * 10000
            Else
                dblO2ppm = -1
            End If
            lblO2Data.Text = CStr(dblO2ppm)

            'エラーコード
            strErrcode = strsubdata(2)
            lblErrcode.Text = strErrcode
            'アラームコード
            strALMcode = strsubdata(3)
            lblALMcode.Text = strALMcode
            
        Catch ex As Exception

        End Try

        Try
            strMsg = Now.ToString & "," & dblO2ppm & "," & lblErrcode.Text & "," & lblALMcode.Text
            TextBox1.Text &= strMsg & ControlChars.CrLf '行追加
            Me.TextBox1.SelectionStart = Me.TextBox1.Text.Length '行の最終に移動
            Me.TextBox1.ScrollToCaret()
            Clslog.WriteA(txtpath.Text & "\" & txtfilename.Text, strMsg)
            System.Windows.Forms.Application.DoEvents()

        Catch ex As Exception

        End Try
    End Sub
    


    Private Sub frmOX400_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub
End Class
